Subject: Re: [p2pi] ALTO service privacy, performance, and architecture

From: Laird Popkin <[email-masked]>
Date: Sun, 3 Aug 2008 00:09:06 -0400 (EDT)

I don't think that p2p users will know or care about ALTO, any more than they know or care about BGP, or HTTP proxies - things just work. ALTO will need to be known about and implemented either by the p2p trackers or clients. At most some applications might provide an ALTO check box as a preference setting, just as they might allow for manual proxy configuration.

Answering the question "And the motivation for pirate trackers would be? ... Improve performance seems slim.", I believe that there are two benefits, one direct and one indirect.

The direct benefit is that localizing data transfers improves download performance for users significantly on average, which makes users happier. While theoretically it shouldn't matter whether data is pulled from nearby sources or far, in practice localizing data sources appears to improve performance quite a bit. I can only guess what the cause of the improved performance is (perhaps shorter RTT's improve TCP throughput, perhaps avoiding congested internet gateways). In any case, we're seeing real world download speeds double and triple for users on fast broadband connections (nothing will speed up a slow broadband connection...).

The indirect benefit is that by reducing the transit costs created by p2p traffic, it reduces the incentives for ISPs to degrade p2p traffic.

"Clients can potentially improve their own performance by choosing closer peers based on IP addresses." How would they know which IP addresses are closer? ALTO?

- Laird Popkin, CTO, Pando Networks
  mobile: 646/465-0570

----- Original Message -----
From: "Reinaldo Penno" <[email-masked]>
To: "Laird Popkin" <[email-masked]>
Cc: [email-masked], "Richard Alimi" <[email-masked]>
Sent: Saturday, August 2, 2008 10:58:44 PM (GMT-0500) America/New_York
Subject: Re: [p2pi] ALTO service privacy, performance, and architecture

On 8/2/08 7:35 PM, "Laird Popkin" <[email-masked]> wrote:

> The P4P tests that were performed so far were performed with legal content so
> that we could focus on technical issues (e.g. implementing and running the
> tests) and not get caught in potentially lengthy policy discussions that (IMO)
> are only worth having once the technology demonstrates its value. The test
> results have been very good, so I suspect that the policy discussions will
> start taking place. There's no technical issue limiting who uses P4P (and, I
> hope, ALTO). Given this, I believe that each ISP can decide its own policies
> regarding who it wants to share what information with.

Understood.

> 
> Keep in mind that ALTO servers can be run by entities other than ISPs. So if
> ISPs don't want to work with pirate trackers, the pirate trackers might join
> together to set up an ALTO server populated using whatever network information
> they can collect or determine (e.g. ASN adjacency maps) to improve performance
> for their users.

And the motivation for pirate trackers would be? There is no business
relationship between P2P clients and their public trackers. Improve
performance seems slim. Clients can potentially improve their own
performance by choosing closer peers based on IP addresses.

> 
> Finally, ALTO servers should be accessible by either clients or servers, so it
> may be the case that even if ISPs don't want to work with pirate trackers,
> they might approve working with user p2p clients, which would achieve a
> similar result.

The latter requires a leap of faith. That's where I think we have different
opinions. I think we need to make sure P2P users are on-board. BTW, by P2P
clients you mean the P2P software or P2P users?

Thanks,

Reinaldo
> 
> - Laird Popkin, CTO, Pando Networks
>   mobile: 646/465-0570
> 
> ----- Original Message -----
> From: "Reinaldo Penno" <[email-masked]>
> To: "Richard Alimi" <[email-masked]>
> Cc: [email-masked]
> Sent: Saturday, August 2, 2008 10:10:11 PM (GMT-0500) America/New_York
> Subject: Re: [p2pi] ALTO service privacy, performance, and architecture
> 
> Hi,
> 
> Thanks for your answers. Comments inline.
> 
> On 8/2/08 6:11 PM, "Richard Alimi" <[email-masked]> wrote:
> 
>>> I just want to remind that we are here because of file-sharing and not
>>> really closed P2P networks where itrackers, apptrackers and others
>>> cooperate nicely. This is the easy case and today does not cause problems
>>> to ISPs. And maybe never will.
>> 
>> Let me make one clarification to your statement above.  The itracker in P4P
>> is
>> not application specific, and thus is not part of any closed system.  It can
>> be queried by many P2P applications, and does not keep any swarm state.  The
>> field tests have been done with Pando, but nothing restricts it from being
>> used for "public" P2P networks.
>> 
>> Or did I misinterpret your meaning of "closed"?
> 
> Closed as in the sense that it assumes cooperation from the AppTracker.
> Otherwise how can it not keep any swarm state? This is is based on the
> functionality from your paper.
> 
> Anyway, the two statements seem contradictory. The corollary is that the
> content that such clients access are those of the P2P CDN and not pirated
> content. The P4P trials that I have heard/read are based on legal content.
> Please correct me if I'm wrong.
> 
>> 
>>> So, when you say "tracker-less" systems you mean a P2P network without a
>>> tracker (Gnutella) or a P2P network where the tracker is something like
>>> thepiratebay? The two 'systems' (as you put it) are quite different.
>> 
>> By "tracker-less," I was referring to a P2P network without a tracker.  We
>> consider thepiratebay a tracker-based system.
>> 
>>> In the case where there is a tracker on the Internet that does not
>>> cooperate (which is 99.99% of P2P traffic today) I'm not sure how ALTO
>>> would work without the ISP tracker pushing information to the clients
>>> (since the clients might not send info to the tracker).
>> 
>> I agree that to cover the majority of the P2P traffic, it may be mostly be
>> client-dependent in the beginning.
>> 
>> The idea, however, is that as time goes on P2P developers and ISPs will each
>> realize the benefits (better performance for P2P apps, and achieve particular
>> network goals for ISPs) and begin support.  Integration should be simple
>> enough that P2P developers understand and use it.
> 
> It is not P2P developers that need to be convinced. It is the users, the
> human factor. 
> 
> And if ALTO does not "get it" that it is not just about having a
> client-server protocol, I'm not sure of the benefits. Yeah, Pando or Joost
> users can be convinced of using it, but how about the other users that are
> responsible for 99.9% of traffic? And if they cannot be convinced, can ALTO
> still do some form of optimization? This goes back to security and privacy.
> 
>> 
>>> For private trackers (which have the really hardcore users) it is not clear
>>> how ALTO can influence their behavior since the whole point is to stay
>>> within the private tracker's given peers. If we cannot tackle these two
>>> scenarios, ISPs continue to suffer.
>> 
>> Interesting point. If there are limited peers in a swarm, then there are
>> limited opportunities for optimization (both for the P2P and ISP side). Is
>> this a fundamental limit, though? Aside, of course, from "telling" them that
>> their swarms should be larger :)
> 
> Well, peers driven by private trackers are the elite. They do not really
> need a big swarm since these are folks that have their computers on 24x7 and
> have Seedboxes. Most of the time they have co-location boxes and/or pay
> enterprise fees to have tons of bandwidth.
> 
>> 
>> Getting adoption in major public P2P clients/trackers is certainly important
>> in order for this to make a large difference for ISP networks.
> 
> I believe, as I said before, that we need to convince users. The only way to
> convince such users is if we have a tight (very tight) security, privacy
> model. Otherwise the ALTO protocol might not see use in the wild.
> 
> As far as convincing public trackers also means convincing the ISP to have a
> relationship with such trackers as thepiratebay. Does Comcast or BT want to
> have such relationship? I have no idea. I guess my point is that the
> business/realities of P2P networks should drive the requirements so we can
> work with (or around them).
> 
> Thanks,
> 
> Reinaldo
> 
> 
> _______________________________________________
> p2pi mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/p2pi

_______________________________________________
p2pi mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/p2pi

---

From: Reinaldo Penno <[email-masked]>
Date: Sat, 02 Aug 2008 23:03:31 -0700

On 8/2/08 9:09 PM, "Laird Popkin" <[email-masked]> wrote:

> I don't think that p2p users will know or care about ALTO, any more than they
> know or care about BGP, or HTTP proxies - things just work. ALTO will need to
> be known about and implemented either by the p2p trackers or clients. At most
> some applications might provide an ALTO check box as a preference setting,
> just as they might allow for manual proxy configuration.

At most or always? If you make it mandatory you are deciding on behalf of
the users who he/she should connect and you are dealing in the net
neutrality realm. I'm not sure MSO and Telcos want to go through FCC battles
again.

> 
> Answering the question "And the motivation for pirate trackers would be? ...
> Improve performance seems slim.", I believe that there are two benefits, one
> direct and one indirect.
> 
> The direct benefit is that localizing data transfers improves download
> performance for users significantly on average, which makes users happier.
> While theoretically it shouldn't matter whether data is pulled from nearby
> sources or far, in practice localizing data sources appears to improve
> performance quite a bit. I can only guess what the cause of the improved
> performance is (perhaps shorter RTT's improve TCP throughput, perhaps avoiding
> congested internet gateways). In any case, we're seeing real world download
> speeds double and triple for users on fast broadband connections (nothing will
> speed up a slow broadband connection...).
> 
> The indirect benefit is that by reducing the transit costs created by p2p
> traffic, it reduces the incentives for ISPs to degrade p2p traffic.

I was talking about what were the incentives for public trackers to perform
optimizations. Your arguments seem to be ISP centric. Public trackers do not
care or are very happy with the current download speeds of their users.
Statistics from these trackers show more bandwidth consumed in a month than
all itunes music sold to date.

> 
> "Clients can potentially improve their own performance by choosing closer
> peers based on IP addresses." How would they know which IP addresses are
> closer? ALTO?

As Stas suggested, a client can easily get access to a full BGP routing
table and perform some optimizations itself. Is this ALTO?

---

From: Reinaldo Penno <[email-masked]>
Date: Sat, 02 Aug 2008 23:46:17 -0700

Laird,

On 8/2/08 9:09 PM, "Laird Popkin" <[email-masked]> wrote:

> know or care about BGP, or HTTP proxies - things just work.

I would say they care a lot. You statement that you "don't think p2p users
will know" does not seem to reflect the transparency we need. Doing anything
under the covers already proved disastrous.

Once bitten, twice shy. I would be surprised if users/EFF/consumers groups
do not scrutinize what is happening with, within the ALTO protocol and how
their information will be used. You have to see it from the users point of
view, the people that complained to the FCC, had connections
dropped/policed/whatever, go to messages board in droves to complain, etc.

Thanks,

Reinaldo

ALTO will need to

---

From: Richard Alimi <[email-masked]>
Date: Sun, 3 Aug 2008 03:12:44 -0400

Hi Reinaldo,

> > I don't think that p2p users will know or care about ALTO, any more than
> > they know or care about BGP, or HTTP proxies - things just work.
>
> will know" does not seem to reflect the transparency we need. Doing
> anything under the covers already proved disastrous.

Yes I agree that what ALTO is actually doing should be transparent, 
particularly in how users' information is disseminated.  But, users should not 
_need_ to know about ALTO to use it. If it does not leak any more private 
information that is done today, then there should be no harm in enabling it by 
default, in which case many users probably wont even know its there. If 
interested users want to find out what ALTO is doing, they are free to do so.

> dropped/policed/whatever, go to messages board in droves to complain, etc.

Certainly agree. The point that I was trying to make earlier, is that ALTO 
should be readily-accessible and implementable by P2P client/developers in 
order for to eventually be used for the majority of P2P traffic in the 
internet.  In addition to this, I fully agree with you that the incentives for 
users to actually use ALTO should be there.  Without both of these 
considerations, it seems that getting widespread adoption of ALTO would be 
difficult.

-- 
Richard Alimi
Department of Computer Science
Yale University

---

From: Marshall Eubanks <[email-masked]>
Date: Mon, 4 Aug 2008 09:59:41 -0400

On Aug 3, 2008, at 2:46 AM, Reinaldo Penno wrote:

> anything

I would tend to agree, especially for the power users. Remember the  
extensive on-line discussion
of TCP resets.

Regards
Marshall

>>> tests) and not get caught in potentially lengthy policy  
>>> discussions that
>>> (IMO)
>>> Finally, ALTO servers should be accessible by either clients or  
>>> servers, so
>>> it